<?php
/**
 * IMPORTANT NOTE
 * The code of this system is closed and a private proprietary of Flex Solutions.
 * A written authorization/license from Flex Solutions is required before using or modifying this code.
 * Email: sales@flexsolution.biz, Phone: +962795342585, Website: http://www.flexsolutions.biz
 */
 
/**
 * This is the model class for table "asset_detailed_dashboard".
 *
 * The followings are the available columns in table 'asset_detailed_dashboard':
 * @property integer $id
 * @property string $date
 * @property integer $asset_id
 * @property integer $type_of_asset_id
 * @property string $expiry_date
 * @property string $status
 * @property integer $grace_period
 * @property integer $days_count
 * @property integer $segment_id
 * @property string $segment_name
 *
 * The followings are the available model relations:
 * @property Asset $asset
 * @property TypeOfAsset $typeOfAsset
 */
class AssetDetailedDashboard extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
	return 'asset_detailed_dashboard';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
	// NOTE: you should only define rules for those attributes that
	// will receive user inputs.
	return array(
	    array('date, asset_id, type_of_asset_id, segment_name', 'required'),
	    array('asset_id, type_of_asset_id, grace_period, days_count, segment_id', 'numerical', 'integerOnly' => true),
	    array('status', 'length', 'max' => 7),
	    array('segment_name', 'length', 'max' => 500),
	    array('expiry_date', 'safe'),
	    // The following rule is used by search().
	    // @todo Please remove those attributes that should not be searched.
	    array('id, date, asset_id, type_of_asset_id, expiry_date, status, grace_period, days_count, segment_id, segment_name', 'safe', 'on' => 'search'),
	);
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
	// NOTE: you may need to adjust the relation name and the related
	// class name for the relations automatically generated below.
	return array(
	    'asset' => array(self::BELONGS_TO, 'Asset', 'asset_id'),
	    'typeOfAsset' => array(self::BELONGS_TO, 'TypeOfAsset', 'type_of_asset_id'),
	);
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
	return array(
	    'id' => 'ID',
	    'date' => 'Date',
	    'asset_id' => 'Asset',
	    'type_of_asset_id' => 'Type Of Asset',
	    'expiry_date' => 'Expiry Date',
	    'status' => 'Status',
	    'grace_period' => 'Days to Expire',
	    'days_count' => 'Days Count',
	    'segment_id' => 'Segment',
	    'segment_name' => 'Segment Name',
	);
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
	// @todo Please modify the following code to remove attributes that should not be searched.

	$criteria = new CDbCriteria;

	$criteria->compare('id', $this->id);
	$criteria->compare('date', $this->date, true);
	$criteria->compare('asset_id', $this->asset_id);
	$criteria->compare('type_of_asset_id', $this->type_of_asset_id);
	$criteria->compare('expiry_date', $this->expiry_date, true);
	$criteria->compare('status', $this->status, true);
	$criteria->compare('grace_period', $this->grace_period);
	$criteria->compare('days_count', $this->days_count);
	$criteria->compare('segment_id', $this->segment_id);
	$criteria->compare('segment_name', $this->segment_name, true);

	return new CActiveDataProvider($this, array(
	    'criteria' => $criteria,
	));

//	if ($type_of_asset != null)
//	    $criteria->compare('type_of_asset_id', $type_of_asset);
//
//	if ($segment != 'Total' && $segment != 'Multi Segment' && $segment != 'None Segment')
//	    $criteria->compare('segment_name', $segment);
//	elseif ($segment == 'Multi Segment')
//	    $criteria->addCondition("segment_name like '%,%'");
//	elseif ($segment == 'None Segment')
//	    $criteria->addCondition("t.segment_name is null");
//
//	if ($status != null) {
//	    if ($status != 'Total')
//		if ($status == 'Fine' || $status == 'Days Count')
//		    $criteria->compare('status', 'Expired');
//		else
//		    $criteria->compare('status', $status);
//	}
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return AssetDetailedDashboard the static model class
     */
    public static function model($className=__CLASS__) {
	return parent::model($className);
    }

}
